# How to implement a JavaScript Web-API

1. Choose the JS Web-API you want to implement from the TODO list below, and find its documentation. The documentation
   can most likely be found on these websites:
    - https://www.w3.org/TR/?tag=webapi
    - https://developer.mozilla.org/en-US/docs/Web/API
    - https://spec.whatwg.org
2. Create a new package in `com.osiris.headlessbrowser.javascript.graal.apis` with your APIs name
3. Inside that new package create a new class named something like `JS_API_MyApiName` and implement the `JS_API`
   interface.
4. Read
   the [JS_API_Example](https://github.com/Osiris-Team/Headless-Browser/blob/main/src/main/java/com/osiris/headlessbrowser/javascript/JS_API_Example.java)
   class for further details.
5. Register/Load your JS Web-API into
   the [JSContext](https://github.com/Osiris-Team/Headless-Browser/blob/main/src/main/java/com/osiris/headlessbrowser/JSContext.java)
   .

## TODO

https://developer.mozilla.org/en-US/docs/Web/API

### B

- Background Fetch API
- Background Tasks
- Barcode Detection API
- Battery API
- Beacon
- Bluetooth API
- Broadcast Channel API

### C

- CSS Counter Styles
- CSS Font Loading API
- CSS Painting API
- CSS Typed Object Model API
- CSSOM
- Canvas API
- Channel Messaging API
- Clipboard API
- Contact Picker API
- Content Index API
- Credential Management API

### D

- DOM

### E

- Encoding API
- Encrypted Media Extensions

### F

- Fetch API
- File System Access API
- File and Directory Entries API
- Frame Timing API
- Fullscreen API

### G

- Gamepad API
- Geolocation API

### H

- HTML Drag and Drop API
- HTML Sanitizer API
- High Resolution Time
- History API

### I

- Image Capture API
- IndexedDB
- Intersection Observer API

### L

- Long Tasks API

### M

- Media Capabilities API
- Media Capture and Streams
- Media Session API
- Media Source Extensions
- MediaStream Recording

### N

- Navigation Timing
- Network Information API

### P

- Page Visibility API
- Payment Request API
- Performance API
- Performance Timeline API
- Periodic Background Sync
- Permissions API
- Picture-in-Picture API
- Pointer Events
- Pointer Lock API
- Presentation API
- Proximity Events
- Push API

### R

- Resize Observer API
- Resource Timing API

### S

- Screen Capture API
- Screen Wake Lock API
- Sensor API
- Server Sent Events
- Service Workers API
- Storage
- Storage Access API
- Streams

### T

- Touch Events

### U

- URL API

### V

- Vibration API
- Visual Viewport

### W

- Web Animations
- Web Audio API
- Web Authentication API
- Web Crypto API
- Web MIDI API
- Web Notifications
- Web Share API
- Web Speech API
- Web Storage API
- Web Workers API
- WebGL
- WebHID API
- WebRTC
- WebVR API
- WebVTT
- WebXR Device API
- Websockets API

### X

- XMLHttpRequest

## DONE

- Console API
